• leetcode 213. House Robber II


    leetcode 213. House Robber II

    You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed. All houses at this place are arranged in a circle. That means the first house is the neighbor of the last one. Meanwhile, adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

    Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

    Example 1:

    Input: [2,3,2]
    Output: 3
    Explanation: You cannot rob house 1 (money = 2) and then rob house 3 (money = 2),
    because they are adjacent houses.
    Example 2:

    Input: [1,2,3,1]
    Output: 4
    Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
    Total amount you can rob = 1 + 3 = 4.

    solution

    动态规划
    对于第{i}家,你可以选择rob or not,如果rob那么第{i-1}家就不能rob,其值为dp[i-2]+nums[i],如果不rob 那么值就为dp[i-1]
    其状态转移方程为
    dp[i] = max{dp[i-1], dp[i-2] + nums[i]}

    由于第一家和最后一家不能都rob,那么第一遍rob (0 to n-2)。第二遍rob(1-n-1)取最大值就可以了

    class Solution {
    public:
        int rob(vector<int>& nums) {
            int n = nums.size();
            if(n == 0)
                return 0;
            if(n == 1)
                return nums[0];
            // rob home form home(0) to home(n-2)
            int dp[n+1];
            dp[0] = nums[0];
            dp[1] = nums[0] > nums[1] ? nums[0] : nums[1];
            for(int i = 2; i < n - 1; i++)
            {
                dp[i] = dp[i-1]>(dp[i-2] + nums[i]) ? dp[i-1] : dp[i-2] + nums[i];
            }
    
            // rob home frome home(1) to home(n-1)
            int dp1[n+1];
            dp1[0]=nums[1];
            if(n>3)
              dp1[1]=nums[1]>nums[2]?nums[1]:nums[2];
    
            for(int i = 2; i < n -1; i++)
            {
                dp1[i] = dp1[i-1]>(dp1[i-2] + nums[i+1]) ? dp1[i-1] : dp1[i-2] + nums[i+1];
            }
    
            if(n>=3)
                dp[n-1]= dp[n-2] > dp1[n-2]  ?dp[n-2] : dp1[n-2] ;
    
            return dp[n-1];
        }
    };
    

    参考链接

    leetcode

    blogs record our growth
  • 相关阅读:
    js内置date类
    获取下拉列表的value
    表单的隐藏与显示
    JavaScript
    CSS的相关属性
    CSS
    基于akka-http搭建restfull框架
    Netsharp配置文件
    nginx配置备忘
    docker安装radis
  • 原文地址:https://www.cnblogs.com/qwfand/p/12671440.html
Copyright © 2020-2023  润新知